<!--Copy media Daniel-->
<script lang="ts">
import Vue from 'vue';
import { SlpHorizontalRule } from '../common/index.vue';

export default Vue.extend({
  name: 'CopyMedia',
  components: {
    SlpHorizontalRule,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
});
</script>

<template>
  <div>
    <div v-for="(block, index) in data.block" :key="index" class="container">
      <span
        v-if="block.metadata"
        :id="block.metadata.id_tag || ''"
        :data-slippers-scroll="block.metadata.id_tag || ''"
      ></span>
      <SlpColumn
        class="copy first-block"
        :class="{
          'first-block--inverted': block.inverted,
          'first-block--column': block.column,
          'first-block--inverted-column':
            block.inverted && block.column && block.column_size,
        }"
        :cols="block.column_size || 12"
      >
        <div class="header-block">
          <SlpIcon
            v-if="block.icon"
            class="slp-mr-16"
            :name="block.icon.name"
            :alt="block.icon.alt"
            :variant="block.icon.variant"
            :hex-color="block.icon.hex_color"
            size="lg"
          />
          <SlpTypography
            v-if="block.header"
            tag="h2"
            variant="heading2"
            class="header-text slp-text-xxl"
          >
            {{ block.header }}
          </SlpTypography>
        </div>
        <SlpTypography
          v-if="block.subtitle"
          tag="h4"
          variant="heading4"
          class="slp-mt-16"
          >{{ block.subtitle }}</SlpTypography
        >
        <img
          class="copy__img--mobile slp-mt-32 slp-mb-16"
          :src="
            block.image_mobile
              ? block.image_mobile.image_url
              : block.image.image_url
          "
          :alt="block.image_mobile ? block.image_mobile.alt : block.image.alt"
          :style="{ filter: block.image.svg_filter_style }"
          loading="lazy"
        />
        <div class="copy__body">
          <div
            v-if="block.text"
            class="slp-mb-32"
            v-html="$md.render(block.text)"
          ></div>
          <a
            v-if="block.link_href"
            :href="block.link_href"
            :variant="block.link_variant"
            :data-ga-name="block.link_data_ga_name"
            :data-ga-location="block.link_data_ga_location"
            >{{ block.link_text }}</a
          >
        </div>
      </SlpColumn>

      <SlpColumn
        class="media second-block"
        :class="{
          'second-block--inverted': block.inverted,
          'second-block--column': block.column,
          'second-block--media': block.image || block.video,
          'second-block--media-inverted-column':
            block.inverted && block.column && block.column_size,
          'media--no-max-height': block.no_max_height,
        }"
        :cols="block.column_size || 12"
      >
        <div
          v-if="block.image"
          :class="{ centered: block.image.vertical_centered }"
        >
          <img
            class="media__img--desktop"
            :src="block.image.image_url"
            :alt="block.image.alt ? block.image.alt : ''"
            :style="{ filter: block.image.svg_filter_style }"
            loading="lazy"
          />

          <div
            v-if="block.image.caption"
            class="image-caption"
            v-html="$md.render(block.image.caption)"
          ></div>
        </div>
        <div
          v-else-if="block.miscellaneous"
          class="copy copy__body"
          v-html="$md.render(block.miscellaneous)"
        ></div>
        <a
          v-if="block.media_link_href"
          :href="block.media_link_href"
          :data-ga-name="block.media_link_data_ga_name"
          :data-ga-location="block.media_link_data_ga_location"
        >
          {{ block.media_link_text }}
        </a>
      </SlpColumn>
      <SlpHorizontalRule v-if="!block.hide_horizontal_rule" />
    </div>
  </div>
</template>

<style lang="scss" scoped>
a {
  margin: 2rem 0;
}

.container {
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  padding: 0 15px;
  margin: 0 auto;
  max-width: 100%;
  position: relative;
  margin-bottom: $spacing-32;

  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(12, 1fr);
    grid-auto-flow: column;
    grid-gap: $spacing-32;
  }

  hr {
    grid-column: 1 / span 12;
    @media (max-width: $breakpoint-lg) {
      margin: 0;
    }
  }
}

.header-block {
  display: flex;
  align-items: center;
  padding-bottom: 20px;

  .header-text {
    color: $color-text-300;
    font-size: 32px;
    line-height: 36px;
    display: block;
    margin-bottom: 0;
  }

  h3 {
    align-self: end;
  }
}

.copy {
  &:deep h3 {
    margin-bottom: $spacing-8;
  }

  &:deep h5 {
    font-size: 20px;
  }

  &:deep h4 {
    font-size: 24px;
  }

  &:deep h4,
  &:deep h5 {
    margin-top: $spacing-32;
    margin-bottom: $spacing-16;
  }

  &:deep img {
    width: 1.3rem;
    margin-right: 0.7rem;
    margin-bottom: $spacing-32;
  }

  &:deep blockquote {
    margin-left: 2rem;
  }

  &__body {
    grid-column: 1 / -1;
    color: $color-text-300;

    &:deep p {
      margin-bottom: 1em;
      font-size: $text-body-1;
    }

    &:deep li {
      font-size: 16px;
    }

    & :deep p a {
      color: $color-text-link-100;
    }
  }

  &__img--mobile {
    display: block;
    min-width: 100%;

    @media (min-width: $breakpoint-lg) {
      display: none;
    }
  }

  @media (max-width: $breakpoint-md) {
    a {
      width: 100%;
    }
  }
}

.copy__bottom_text {
  grid-column: 1 / span 12;
  display: flex;
  justify-content: center;
  align-items: center;

  @media (min-width: $breakpoint-lg) {
    grid-row: 2/3;
  }
}

.media {
  &__img {
    &--desktop {
      display: none;

      @media (min-width: $breakpoint-lg) {
        display: block;
      }
    }
  }

  .image-caption {
    font-style: italic;
  }

  &--no-max-height {
    img {
      max-height: unset !important;
    }
  }

  img {
    width: 100%;
    object-fit: scale-down;
    max-height: 20rem;
    margin-bottom: $spacing-32;

    &[src*='\.svg'] {
      object-fit: fill;
    }
  }

  iframe {
    display: block;
    margin: 0 auto;
    max-width: 100%;
    border: 1px solid #f2f2f2;
  }
}

.first-block {
  grid-column: 1 / 12;

  &.slp-col-md-8.first-block--column {
    margin: 0 auto; // centers Topics content with embedded video
  }

  &--column {
    grid-column: 1 / 12;

    &.first-block--inverted {
      grid-row: 2;
    }
  }

  @media (min-width: $breakpoint-lg) {
    grid-column: 1 / span 6;
    padding-right: $spacing-16;
    padding-left: 0;

    &--inverted {
      grid-column: 7 / span 6;
      padding-right: 0;
      padding-left: $spacing-16;
      &-column {
        margin: 0 auto;
      }
    }

    &--column {
      grid-column: 1 / span 12;
    }
  }
}

.second-block {
  grid-column: 1 / 12;

  &.slp-col-md-8.second-block--column {
    margin: 0 auto $spacing-64 auto; // centers Topics content with embedded video
  }

  &--media {
    min-height: 200px;

    &-inverted-column {
      margin: 0 auto;
    }

    @media (max-width: $breakpoint-md) {
      min-height: $spacing-48;
    }
  }

  &--column {
    grid-column: 1 / 12;

    &.second-block--inverted {
      grid-row: 1;
    }
  }

  @media (min-width: $breakpoint-lg) {
    grid-column: 7 / span 6;
    padding: 0;

    &--inverted {
      grid-column: 1 / span 6;
      padding: 0;
    }

    &--column {
      grid-column: 1 / span 12;
    }

    &--column + &--inverted {
      grid-row: 1;
    }

    &--centered {
      align-self: center;
    }
  }

  & > div {
    width: 100%;

    &.centered {
      align-self: center;
    }
  }
}
</style>
